diff -ru '--exclude=.svn' trunk/release/scripts/startup/bl_ui/space_clip.py svn/release/scripts/startup/bl_ui/space_clip.py
--- trunk/release/scripts/startup/bl_ui/space_clip.py	2013-09-22 13:26:24.000000000 +0100
+++ svn/release/scripts/startup/bl_ui/space_clip.py	2013-09-22 13:10:32.000000000 +0100
@@ -353,6 +353,19 @@
         col.prop(settings, "refine_intrinsics", text="")
 
         col = layout.column(align=True)
+        col.active = "FOCAL_LENGTH" in settings.refine_intrinsics
+        col.prop(settings, "use_focal_length_constraint");
+        sub = col.column(align=True)
+        sub.active = settings.use_focal_length_constraint
+        if tracking.camera.units == 'MILLIMETERS':
+            sub.prop(settings, "focal_length_min", text="Min")
+            sub.prop(settings, "focal_length_max", text="Max")
+        else:
+            sub.prop(settings, "focal_length_min_pixels", text="Min")
+            sub.prop(settings, "focal_length_max_pixels", text="Max")
+
+
+        col = layout.column(align=True)
         col.active = not settings.use_tripod_solver
         col.prop(settings, "use_fallback_reconstruction",
                  text="Allow Fallback")
@@ -943,6 +956,17 @@
         layout.operator("clip.set_scene_frames")
 
 
+class CLIP_PT_multicamera_clip(CLIP_PT_clip_view_panel, Panel):
+    bl_space_type = 'CLIP_EDITOR'
+    bl_region_type = 'TOOLS'
+    bl_label = "Multicamera"
+
+    def draw(self, context):
+        layout = self.layout
+
+        layout.operator("clip.create_correspondence")
+
+
 class CLIP_MT_view(Menu):
     bl_label = "View"
 
diff -ru '--exclude=.svn' trunk/source/blender/blenkernel/BKE_tracking.h svn/source/blender/blenkernel/BKE_tracking.h
--- trunk/source/blender/blenkernel/BKE_tracking.h	2013-09-22 13:26:51.000000000 +0100
+++ svn/source/blender/blenkernel/BKE_tracking.h	2013-09-22 13:11:54.000000000 +0100
@@ -160,6 +160,7 @@
                                                                            struct MovieTrackingObject *object);
 
 /* **** Camera **** */
+void BKE_tracking_camera_focal_length_set(struct MovieTracking *tracking, float value);
 void BKE_tracking_camera_shift_get(struct MovieTracking *tracking, int winx, int winy, float *shiftx, float *shifty);
 void BKE_tracking_camera_to_blender(struct MovieTracking *tracking, struct Scene *scene,
                                     struct Camera *camera, int width, int height);
diff -ru '--exclude=.svn' trunk/source/blender/blenkernel/intern/movieclip.c svn/source/blender/blenkernel/intern/movieclip.c
--- trunk/source/blender/blenkernel/intern/movieclip.c	2013-09-22 13:26:50.000000000 +0100
+++ svn/source/blender/blenkernel/intern/movieclip.c	2013-09-20 16:35:35.000000000 +0100
@@ -57,6 +57,8 @@
 #include "DNA_scene_types.h"
 #include "DNA_view3d_types.h"
 
+#include "RNA_access.h"
+
 #include "BLI_utildefines.h"
 
 #include "BLI_blenlib.h"
@@ -657,10 +659,12 @@
 	detect_clip_source(clip);
 
 	movieclip_load_get_szie(clip);
+
 	if (clip->lastsize[0]) {
 		int width = clip->lastsize[0];
-
-		clip->tracking.camera.focal = 24.0f * width / clip->tracking.camera.sensor_width;
+ 
+		float focal = 24.0f * width / clip->tracking.camera.sensor_width;
+		BKE_tracking_camera_focal_length_set(&clip->tracking, focal);
 	}
 
 	movieclip_calc_length(clip);
diff -ru '--exclude=.svn' trunk/source/blender/blenkernel/intern/tracking.c svn/source/blender/blenkernel/intern/tracking.c
--- trunk/source/blender/blenkernel/intern/tracking.c	2013-09-22 13:26:50.000000000 +0100
+++ svn/source/blender/blenkernel/intern/tracking.c	2013-09-22 13:11:50.000000000 +0100
@@ -213,6 +213,8 @@
 	tracking->settings.dist = 1;
 	tracking->settings.object_distance = 1;
 	tracking->settings.reconstruction_success_threshold = 1e-3f;
+	tracking->settings.focal_length_min = 0.0f;
+	tracking->settings.focal_length_max = 5000.0f;
 
 	tracking->stabilization.scaleinf = 1.0f;
 	tracking->stabilization.locinf = 1.0f;
@@ -1798,6 +1800,20 @@
 	}
 }
 
+void BKE_tracking_camera_focal_length_set(MovieTracking *tracking, float value)
+{
+	MovieTrackingSettings *settings = &tracking->settings;
+	MovieTrackingCamera *camera = &tracking->camera;
+
+	if (!(settings->refine_intrinsics & REFINE_FOCAL_LENGTH) ||
+	    !(settings->constrain_intrinsics & CONSTRAIN_FOCAL_LENGTH))
+	{
+		settings->focal_length_min = value;
+		settings->focal_length_max = value;
+	}
+
+	camera->focal = value;
+}
 
 /* converts principal offset from center to offset of blender's camera */
 void BKE_tracking_camera_shift_get(MovieTracking *tracking, int winx, int winy, float *shiftx, float *shifty)
@@ -3455,7 +3471,9 @@
 	struct libmv_Tracks *tracks;
 	bool select_keyframes;
 	int keyframe1, keyframe2;
-	int refine_flags;
+	short refine_intrinsics;
+	short constrain_intrinsics;
+	float focal_length_min, focal_length_max;
 
 	struct libmv_Reconstruction *reconstruction;
 
@@ -3504,7 +3522,8 @@
 			if ((marker->flag & MARKER_DISABLED) == 0) {
 				libmv_tracksInsert(tracks, marker->framenr, tracknr,
 				                   (marker->pos[0] + track->offset[0]) * width,
-				                   (marker->pos[1] + track->offset[1]) * height);
+				                   (marker->pos[1] + track->offset[1]) * height,
+													 0);
 			}
 		}
 
@@ -3519,7 +3538,7 @@
 static void reconstruct_retrieve_libmv_intrinsics(MovieReconstructContext *context, MovieTracking *tracking)
 {
 	struct libmv_Reconstruction *libmv_reconstruction = context->reconstruction;
-	struct libmv_CameraIntrinsics *libmv_intrinsics = libmv_reconstructionExtractIntrinsics(libmv_reconstruction);
+	struct libmv_CameraIntrinsics *libmv_intrinsics = libmv_reconstructionExtractIntrinsics(libmv_reconstruction, 0);
 
 	float aspy = 1.0f / tracking->camera.pixel_aspect;
 
@@ -3674,27 +3693,38 @@
 }
 
 /* Convert blender's refinement flags to libmv's. */
-static int reconstruct_refine_intrinsics_get_flags(MovieTracking *tracking, MovieTrackingObject *object)
-{
-	int refine = tracking->settings.refine_camera_intrinsics;
-	int flags = 0;
+static void reconstruct_refine_intrinsics_get_flags(const MovieTracking *tracking,
+                                                    const MovieTrackingObject *object,
+                                                    MovieReconstructContext *context)
+{
+	short refine = tracking->settings.refine_intrinsics;
+	short constrain = tracking->settings.constrain_intrinsics;
+	short libmv_refine = 0;
+	short libmv_constrain = 0;
 
-	if ((object->flag & TRACKING_OBJECT_CAMERA) == 0)
-		return 0;
+	if ((object->flag & TRACKING_OBJECT_CAMERA) == 0) {
+		context->refine_intrinsics = 0;
+		context->constrain_intrinsics = 0;
+		return;
+	}
 
-	if (refine & REFINE_FOCAL_LENGTH)
-		flags |= LIBMV_REFINE_FOCAL_LENGTH;
+	if (refine & REFINE_FOCAL_LENGTH) {
+		libmv_refine |= LIBMV_REFINE_FOCAL_LENGTH;
+		if (constrain & CONSTRAIN_FOCAL_LENGTH)
+			libmv_constrain |= LIBMV_CONSTRAIN_FOCAL_LENGTH;
+	}
 
 	if (refine & REFINE_PRINCIPAL_POINT)
-		flags |= LIBMV_REFINE_PRINCIPAL_POINT;
+		libmv_refine |= LIBMV_REFINE_PRINCIPAL_POINT;
 
 	if (refine & REFINE_RADIAL_DISTORTION_K1)
-		flags |= LIBMV_REFINE_RADIAL_DISTORTION_K1;
+		libmv_refine |= LIBMV_REFINE_RADIAL_DISTORTION_K1;
 
 	if (refine & REFINE_RADIAL_DISTORTION_K2)
-		flags |= LIBMV_REFINE_RADIAL_DISTORTION_K2;
+		libmv_refine |= LIBMV_REFINE_RADIAL_DISTORTION_K2;
 
-	return flags;
+	context->refine_intrinsics = libmv_refine;
+	context->constrain_intrinsics = libmv_constrain;
 }
 
 /* Count tracks which has markers at both of keyframes. */
@@ -3820,7 +3850,10 @@
 	context->tracks = libmv_tracks_new(tracksbase, width, height * aspy);
 	context->keyframe1 = keyframe1;
 	context->keyframe2 = keyframe2;
-	context->refine_flags = reconstruct_refine_intrinsics_get_flags(tracking, object);
+
+	reconstruct_refine_intrinsics_get_flags(tracking, object, context);
+	context->focal_length_min = tracking->settings.focal_length_min;
+	context->focal_length_max = tracking->settings.focal_length_max;
 
 	return context;
 }
@@ -3851,10 +3884,12 @@
 	BLI_snprintf(progressdata->stats_message, progressdata->message_size, "Solving camera | %s", message);
 }
 /* FIll in camera intrinsics structure from reconstruction context. */
-static void camraIntrincicsOptionsFromContext(libmv_CameraIntrinsicsOptions *camera_intrinsics_options,
-                                              MovieReconstructContext *context)
+static void cameraIntrinsicsOptionsFromContext(const MovieReconstructContext *context,
+                                               libmv_CameraIntrinsicsOptions *camera_intrinsics_options)
 {
 	camera_intrinsics_options->focal_length = context->focal_length;
+	CLAMP(camera_intrinsics_options->focal_length,
+	      context->focal_length_min, context->focal_length_max);
 
 	camera_intrinsics_options->principal_point_x = context->principal_point[0];
 	camera_intrinsics_options->principal_point_y = context->principal_point[1];
@@ -3868,15 +3903,20 @@
 }
 
 /* Fill in reconstruction options structure from reconstruction context. */
-static void reconstructionOptionsFromContext(libmv_ReconstructionOptions *reconstruction_options,
-                                             MovieReconstructContext *context)
+static void reconstructionOptionsFromContext(MovieReconstructContext *context,
+                                             libmv_ReconstructionOptions *reconstruction_options)
 {
 	reconstruction_options->select_keyframes = context->select_keyframes;
 
 	reconstruction_options->keyframe1 = context->keyframe1;
 	reconstruction_options->keyframe2 = context->keyframe2;
 
-	reconstruction_options->refine_intrinsics = context->refine_flags;
+	reconstruction_options->motion_flag = context->motion_flag;
+
+	reconstruction_options->refine_intrinsics = context->refine_intrinsics;
+	reconstruction_options->constrain_intrinsics = context->constrain_intrinsics;
+	reconstruction_options->focal_length_min = context->focal_length_min;
+	reconstruction_options->focal_length_max = context->focal_length_max;
 
 	reconstruction_options->success_threshold = context->success_threshold;
 	reconstruction_options->use_fallback_reconstruction = context->use_fallback_reconstruction;
@@ -3907,26 +3947,20 @@
 	progressdata.stats_message = stats_message;
 	progressdata.message_size = message_size;
 
-	camraIntrincicsOptionsFromContext(&camera_intrinsics_options, context);
-	reconstructionOptionsFromContext(&reconstruction_options, context);
+	cameraIntrinsicsOptionsFromContext(context, &camera_intrinsics_options);
+	reconstructionOptionsFromContext(context, &reconstruction_options);
 
-	if (context->motion_flag & TRACKING_MOTION_MODAL) {
-		context->reconstruction = libmv_solveModal(context->tracks,
-		                                           &camera_intrinsics_options,
-		                                           &reconstruction_options,
-		                                           reconstruct_update_solve_cb, &progressdata);
-	}
-	else {
-		context->reconstruction = libmv_solveReconstruction(context->tracks,
-		                                                    &camera_intrinsics_options,
-		                                                    &reconstruction_options,
-		                                                    reconstruct_update_solve_cb, &progressdata);
-
-		if (context->select_keyframes) {
-			/* store actual keyframes used for reconstruction to update them in the interface later */
-			context->keyframe1 = reconstruction_options.keyframe1;
-			context->keyframe2 = reconstruction_options.keyframe2;
-		}
+	context->reconstruction = libmv_solve(context->tracks,
+	                                      &camera_intrinsics_options,
+	                                      &reconstruction_options,
+	                                      reconstruct_update_solve_cb,
+	                                      &progressdata);
+	if ((context->motion_flag & TRACKING_MOTION_MODAL) &&
+	    context->select_keyframes)
+	{
+		/* store actual keyframes used for reconstruction to update them in the interface later */
+		context->keyframe1 = reconstruction_options.keyframe1;
+		context->keyframe2 = reconstruction_options.keyframe2;
 	}
 
 	error = libmv_reprojectionError(context->reconstruction);
diff -ru '--exclude=.svn' trunk/source/blender/editors/space_clip/clip_intern.h svn/source/blender/editors/space_clip/clip_intern.h
--- trunk/source/blender/editors/space_clip/clip_intern.h	2013-09-22 13:27:05.000000000 +0100
+++ svn/source/blender/editors/space_clip/clip_intern.h	2013-09-22 13:10:32.000000000 +0100
@@ -201,6 +201,8 @@
 void CLIP_OT_keyframe_insert(struct wmOperatorType *ot);
 void CLIP_OT_keyframe_delete(struct wmOperatorType *ot);
 
+void CLIP_OT_create_correspondence(struct wmOperatorType *ot);
+
 /* tracking_select.c */
 void CLIP_OT_select(struct wmOperatorType *ot);
 void CLIP_OT_select_all(struct wmOperatorType *ot);
diff -ru '--exclude=.svn' trunk/source/blender/editors/space_clip/space_clip.c svn/source/blender/editors/space_clip/space_clip.c
--- trunk/source/blender/editors/space_clip/space_clip.c	2013-09-22 13:27:05.000000000 +0100
+++ svn/source/blender/editors/space_clip/space_clip.c	2013-09-22 13:10:32.000000000 +0100
@@ -526,6 +526,9 @@
 	WM_operatortype_append(CLIP_OT_keyframe_insert);
 	WM_operatortype_append(CLIP_OT_keyframe_delete);
 
+	/* Multicamera */
+	WM_operatortype_append(CLIP_OT_create_correspondence);
+
 	/* ** clip_graph_ops.c  ** */
 
 	/* graph editing */
diff -ru '--exclude=.svn' trunk/source/blender/editors/space_clip/tracking_ops.c svn/source/blender/editors/space_clip/tracking_ops.c
--- trunk/source/blender/editors/space_clip/tracking_ops.c	2013-09-22 13:27:06.000000000 +0100
+++ svn/source/blender/editors/space_clip/tracking_ops.c	2013-09-22 13:12:55.000000000 +0100
@@ -4198,3 +4198,20 @@
 	/* flags */
 	ot->flag = OPTYPE_REGISTER | OPTYPE_UNDO;
 }
+
+/********************** Multicamera operators ******************************/
+
+void CLIP_OT_create_correspondence(wmOperatorType *ot)
+{
+	/* identifiers */
+	ot->name = "Create correspondence";
+	ot->description = "Create a correspondence between selected tracks across multiple clips";
+	ot->idname = "CLIP_OT_create_correspondence";
+
+	/* api callbacks */
+	//ot->poll = ;
+	//ot->exec = ;
+
+	/* flags */
+	ot->flag = OPTYPE_REGISTER | OPTYPE_UNDO;
+}
diff -ru '--exclude=.svn' trunk/source/blender/makesdna/DNA_tracking_types.h svn/source/blender/makesdna/DNA_tracking_types.h
--- trunk/source/blender/makesdna/DNA_tracking_types.h	2013-09-22 13:26:51.000000000 +0100
+++ svn/source/blender/makesdna/DNA_tracking_types.h	2013-09-22 13:11:55.000000000 +0100
@@ -210,8 +210,10 @@
 	float reconstruction_success_threshold;
 	int reconstruction_flag;
 
-	/* which camera intrinsics to refine. uses on the REFINE_* flags */
-	short refine_camera_intrinsics, pad2;
+	/* refinement */
+	short refine_intrinsics;                  /* camera intrinsics to refine */
+	short constrain_intrinsics;               /* camera intrinsics to constrain */
+	float focal_length_min, focal_length_max; /* minimum and maximum values for focal length refinement in pixels */
 
 	/* ** tool settings ** */
 
@@ -413,7 +415,7 @@
 	TRACKING_USE_KEYFRAME_SELECTION      = (1 << 1)
 };
 
-/* MovieTrackingSettings->refine_camera_intrinsics */
+/* MovieTrackingSettings->refine_intrinsics */
 enum {
 	REFINE_FOCAL_LENGTH         = (1 << 0),
 	REFINE_PRINCIPAL_POINT      = (1 << 1),
@@ -421,6 +423,11 @@
 	REFINE_RADIAL_DISTORTION_K2 = (1 << 4)
 };
 
+/* MovieTrackingSettings->constrain_intrinsics */
+enum {
+	CONSTRAIN_FOCAL_LENGTH      = (1 << 0)
+};
+
 /* MovieTrackingStrabilization->flag */
 enum {
 	TRACKING_2D_STABILIZATION   = (1 << 0),
diff -ru '--exclude=.svn' trunk/source/blender/makesrna/intern/rna_tracking.c svn/source/blender/makesrna/intern/rna_tracking.c
--- trunk/source/blender/makesrna/intern/rna_tracking.c	2013-09-22 13:26:57.000000000 +0100
+++ svn/source/blender/makesrna/intern/rna_tracking.c	2013-09-22 13:12:11.000000000 +0100
@@ -55,6 +55,76 @@
 
 #include "WM_api.h"
 
+static void rna_trackingSettings_focal_length_min_pixels_set(PointerRNA *ptr, float value)
+{
+	MovieClip *clip = (MovieClip *)ptr->id.data;
+	MovieTrackingSettings *settings = &clip->tracking.settings;
+
+	if (value > settings->focal_length_max)
+		value = settings->focal_length_max;
+
+	settings->focal_length_min = value;
+}
+
+static void rna_trackingSettings_focal_length_max_pixels_set(PointerRNA *ptr, float value)
+{
+	MovieClip *clip = (MovieClip *)ptr->id.data;
+	MovieTrackingSettings *settings = &clip->tracking.settings;
+
+	if (value < settings->focal_length_min)
+		value = settings->focal_length_min;
+
+	settings->focal_length_max = value;
+}
+
+static float rna_trackingSettings_focal_length_min_get(PointerRNA *ptr)
+{
+	MovieClip *clip = (MovieClip *)ptr->id.data;
+	MovieTrackingSettings *settings = &clip->tracking.settings;
+	MovieTrackingCamera *camera = &clip->tracking.camera;
+	float value = settings->focal_length_min;
+
+	if (clip->lastsize[0])
+		value = value * camera->sensor_width / (float)clip->lastsize[0];
+	
+	return value;
+}
+
+static void rna_trackingSettings_focal_length_min_set(PointerRNA *ptr, float value)
+{
+	MovieClip *clip = (MovieClip *)ptr->id.data;
+	MovieTrackingCamera *camera = &clip->tracking.camera;
+
+	if (clip->lastsize[0])
+		value = clip->lastsize[0] * value / camera->sensor_width;
+
+	rna_trackingSettings_focal_length_min_pixels_set(ptr, value);
+}
+
+static float rna_trackingSettings_focal_length_max_get(PointerRNA *ptr)
+{
+	MovieClip *clip = (MovieClip *)ptr->id.data;
+	MovieTrackingSettings *settings = &clip->tracking.settings;
+	MovieTrackingCamera *camera = &clip->tracking.camera;
+	float value = settings->focal_length_max;
+
+	if (clip->lastsize[0])
+		value = value * camera->sensor_width / (float)clip->lastsize[0];
+	
+	return value;
+}
+
+static void rna_trackingSettings_focal_length_max_set(PointerRNA *ptr, float value)
+{
+	MovieClip *clip = (MovieClip *)ptr->id.data;
+	MovieTrackingCamera *camera = &clip->tracking.camera;
+
+	if (clip->lastsize[0])
+		value = clip->lastsize[0] * value / camera->sensor_width;
+
+	rna_trackingSettings_focal_length_max_pixels_set(ptr, value);
+}
+
 static char *rna_tracking_path(PointerRNA *UNUSED(ptr))
 {
 	return BLI_sprintfN("tracking");
@@ -306,7 +376,13 @@
 	return BLI_sprintfN("tracking.camera");
 }
 
-static float rna_trackingCamera_focal_mm_get(PointerRNA *ptr)
+static void rna_trackingCamera_focal_length_pixels_set(PointerRNA *ptr, float value)
+{
+	MovieClip *clip = (MovieClip *)ptr->id.data;
+	BKE_tracking_camera_focal_length_set(&clip->tracking, value);
+}
+
+static float rna_trackingCamera_focal_length_get(PointerRNA *ptr)
 {
 	MovieClip *clip = (MovieClip *)ptr->id.data;
 	MovieTrackingCamera *camera = &clip->tracking.camera;
@@ -318,7 +394,7 @@
 	return val;
 }
 
-static void rna_trackingCamera_focal_mm_set(PointerRNA *ptr, float value)
+static void rna_trackingCamera_focal_length_set(PointerRNA *ptr, float value)
 {
 	MovieClip *clip = (MovieClip *)ptr->id.data;
 	MovieTrackingCamera *camera = &clip->tracking.camera;
@@ -327,7 +403,7 @@
 		value = clip->lastsize[0] * value / camera->sensor_width;
 
 	if (value >= 0.0001f)
-		camera->focal = value;
+		BKE_tracking_camera_focal_length_set(&clip->tracking, value);
 }
 
 static char *rna_trackingStabilization_path(PointerRNA *UNUSED(ptr))
@@ -795,11 +871,56 @@
 
 	/* intrinsics refinement during bundle adjustment */
 	prop = RNA_def_property(srna, "refine_intrinsics", PROP_ENUM, PROP_NONE);
-	RNA_def_property_enum_sdna(prop, NULL, "refine_camera_intrinsics");
+	RNA_def_property_enum_sdna(prop, NULL, "refine_intrinsics");
 	RNA_def_property_clear_flag(prop, PROP_ANIMATABLE);
 	RNA_def_property_enum_items(prop, refine_items);
 	RNA_def_property_ui_text(prop, "Refine", "Refine intrinsics during camera solving");
 
+	/* constrain focal length for intrinsics refinement */
+	prop = RNA_def_property(srna, "use_focal_length_constraint", PROP_BOOLEAN, PROP_NONE);
+	RNA_def_property_clear_flag(prop, PROP_ANIMATABLE);
+	RNA_def_property_boolean_sdna(prop, NULL, "constrain_intrinsics", CONSTRAIN_FOCAL_LENGTH);
+	RNA_def_property_ui_text(prop, "Constrain Focal Length",
+	                         "Constrain the focal length during intrinsics refinement");
+
+	/* focal length constraint values in pixels */
+	prop = RNA_def_property(srna, "focal_length_min_pixels", PROP_FLOAT, PROP_NONE);
+	RNA_def_property_clear_flag(prop, PROP_ANIMATABLE);
+	RNA_def_property_float_sdna(prop, NULL, "focal_length_min");
+	RNA_def_property_range(prop, 0.0f, 10000.0f);
+	RNA_def_property_float_default(prop, 0.0f);
+	RNA_def_property_float_funcs(prop, NULL, "rna_trackingSettings_focal_length_min_pixels_set", NULL);
+	RNA_def_property_ui_text(prop, "Min Focal Length",
+	                         "Minimum focal length in pixels");
+
+	prop = RNA_def_property(srna, "focal_length_max_pixels", PROP_FLOAT, PROP_NONE);
+	RNA_def_property_clear_flag(prop, PROP_ANIMATABLE);
+	RNA_def_property_float_sdna(prop, NULL, "focal_length_max");
+	RNA_def_property_range(prop, 0.0f, 10000.0f);
+	RNA_def_property_float_default(prop, 10000.0f);
+	RNA_def_property_float_funcs(prop, NULL, "rna_trackingSettings_focal_length_max_pixels_set", NULL);
+	RNA_def_property_ui_text(prop, "Max Focal Length",
+	                         "Maximum focal length in pixels");
+
+	/* focal length constraint values in millimeters */
+	prop = RNA_def_property(srna, "focal_length_min", PROP_FLOAT, PROP_NONE);
+	RNA_def_property_clear_flag(prop, PROP_ANIMATABLE);
+	RNA_def_property_range(prop, 0.0f, 10000.0f);
+	RNA_def_property_float_default(prop, 0.0f);
+	RNA_def_property_float_funcs(prop, "rna_trackingSettings_focal_length_min_get",
+	                                   "rna_trackingSettings_focal_length_min_set", NULL);
+	RNA_def_property_ui_text(prop, "Min Focal Length",
+	                         "Minimum focal length in millimeters");
+
+	prop = RNA_def_property(srna, "focal_length_max", PROP_FLOAT, PROP_NONE);
+	RNA_def_property_clear_flag(prop, PROP_ANIMATABLE);
+	RNA_def_property_range(prop, 0.0f, 10000.0f);
+	RNA_def_property_float_default(prop, 10000.0f);
+	RNA_def_property_float_funcs(prop, "rna_trackingSettings_focal_length_max_get",
+	                                   "rna_trackingSettings_focal_length_max_set", NULL);
+	RNA_def_property_ui_text(prop, "Max Focal Length",
+	                         "Maximum focal length in millimeters");
+
 	/* tool settings */
 
 	/* distance */
@@ -979,7 +1100,8 @@
 	RNA_def_property_float_sdna(prop, NULL, "focal");
 	RNA_def_property_clear_flag(prop, PROP_ANIMATABLE);
 	RNA_def_property_range(prop, 0.0001f, 5000.0f);
-	RNA_def_property_float_funcs(prop, "rna_trackingCamera_focal_mm_get", "rna_trackingCamera_focal_mm_set", NULL);
+	RNA_def_property_float_funcs(prop, "rna_trackingCamera_focal_length_get",
+	                                   "rna_trackingCamera_focal_length_set", NULL);
 	RNA_def_property_ui_text(prop, "Focal Length", "Camera's focal length");
 	RNA_def_property_update(prop, NC_MOVIECLIP | NA_EDITED, NULL);
 
@@ -988,6 +1110,7 @@
 	RNA_def_property_float_sdna(prop, NULL, "focal");
 	RNA_def_property_clear_flag(prop, PROP_ANIMATABLE);
 	RNA_def_property_range(prop, 0.0f, 5000.0f);
+	RNA_def_property_float_funcs(prop, NULL, "rna_trackingCamera_focal_length_pixels_set", NULL);
 	RNA_def_property_ui_text(prop, "Focal Length", "Camera's focal length");
 	RNA_def_property_update(prop, NC_MOVIECLIP | NA_EDITED, NULL);
 
@@ -995,9 +1118,9 @@
 	prop = RNA_def_property(srna, "units", PROP_ENUM, PROP_NONE);
 	RNA_def_property_enum_sdna(prop, NULL, "units");
 	RNA_def_property_clear_flag(prop, PROP_ANIMATABLE);
-	RNA_def_property_clear_flag(prop, PROP_ANIMATABLE);
 	RNA_def_property_enum_items(prop, camera_units_items);
 	RNA_def_property_ui_text(prop, "Units", "Units used for camera focal length");
+	RNA_def_property_update(prop, NC_MOVIECLIP | NA_EDITED, NULL);
 
 	/* Principal Point */
 	prop = RNA_def_property(srna, "principal", PROP_FLOAT, PROP_NONE);
Only in svn/source/tools: check_style_c_config.pyc
Only in svn/source/tools: __pycache__
